# -*- coding: utf-8 -*-
import os
import random
import sys
import datetime


sys.path.append(os.getcwd())
from common.feishu_utils import Feishu


class Material():
    """
    获取汇总表所有负责人列表
    """
    @classmethod
    def feishu_list(cls):
        summary = Feishu.get_values_batch("summary", "3e1295")
        list = []
        for row in summary[1:]:
            mark = row[0]
            name = row[1]
            feishu_id = row[3]
            feishu_sheet = row[4]
            number = {"mark": mark, "name": name, "feishu_id": feishu_id, "feishu_sheet": feishu_sheet}
            if mark:
                list.append(number)
            else:
                return list
        return list

    """
    获取对应负责人任务明细
    """
    @classmethod
    def get_task_data(cls, feishu_id, feishu_sheet):
        data = Feishu.get_values_batch(feishu_id, feishu_sheet)
        list = []
        for row in data[1:]:
            task_mark = row[0]
            old_id = row[1]
            video_id = row[2]
            new_id = row[3]
            number = row[4]
            title = row[5]
            if new_id != 'None' and new_id != '' and new_id != None:
                number = {"task_mark": task_mark, "old_id": old_id, "video_id": video_id, "new_id": new_id,
                          "number": number, "title": title}
                list.append(number)
            else:
                return list
        return list







