import configparser
import os
import random

import time


from datetime import datetime
from common import Material, Feishu, Common, Oss
from common.piaoquan_utils import PQ
from common.sql_help import sqlCollect

config = configparser.ConfigParser()
config.read('./config.ini')  # 替换为您的配置文件路径
class getVideo():

    """
    数据处理
    """
    @classmethod
    def get_video(cls):
        pass

    """
    创建目录
    """
    @classmethod
    def create_folders(cls, task_mark):
        video_path_url = config['PATHS']['VIDEO_PATH'] + task_mark + "/"
        if not os.path.exists(video_path_url):
            os.makedirs(video_path_url)
        return video_path_url

    """
    随机生成ID
    """
    @classmethod
    def random_id(cls):
        now = datetime.now()
        rand_num = random.randint(10000, 99999)
        oss_id = "{}{}".format(now.strftime("%Y%m%d%H%M%S"), rand_num)
        return oss_id
    """
    飞书数据处理
    """
    @classmethod
    def video_task(cls, data):
        mark = data["mark"]
        name = data["name"]
        feishu_id = data["feishu_id"]
        feishu_sheet = data["feishu_sheet"]
        task_data = Material.get_task_data(feishu_id, feishu_sheet)
        if len(task_data) == 0:
            Feishu.bot(mark, '机器自动改造消息通知', f'今日任务为空，请关注', name)
            return mark
        for task in task_data:
            task_mark = task["task_mark"]
            old_id = str(task["old_id"])
            video_id = str(task["video_id"])
            new_id = str(task["new_id"])

            number = task["number"] #指定条数
            title = task["title"]
            try:
                video_path_url = cls.create_folders(str(task_mark))
                if ',' in new_id:
                    n_id = new_id.split(',')
                else:
                    n_id = [new_id]
                if old_id != 'None' and old_id != '' and old_id != None:
                    if ',' in old_id:
                        task_id = old_id.split(',')
                    else:
                        task_id = [old_id]
                else:
                    if ',' in video_id:
                        task_id = video_id.split(',')
                    else:
                        task_id = [video_id]
                for id in task_id:
                    time.sleep(1)
                    if old_id != 'None' and old_id != '' and old_id != None:
                        data_list = PQ.get_user_url(task_mark, id, number, title)
                    else:
                        data_list = PQ.get_audio_url(task_mark, id, title)
                    if len(data_list) == 0 or data_list == "":
                        Common.logger("log").info(f"{task_mark}下的视频ID{id} 近三天已经改造过了")
                        Feishu.bot(mark, '机器自动改造消息通知', f'{task_mark}任务下的视频ID{id},近三天已经改造过，请关注', name)
                        continue
                    for video in data_list:
                        v_id = video["video_id"]
                        new_title = video["title"]
                        cover = video["cover"]
                        video_url = video["video_url"]
                        new_video_path = PQ.download_video(video_url, video_path_url, v_id)
                        if len(new_video_path) == 0 or new_video_path == "":
                            Common.logger("log").info(f"{task_mark}下的视频ID{id},{new_video_path}视频下载失败")
                            continue
                        oss_id = cls.random_id()
                        oss_object_key = Oss.stitching_sync_upload_oss(new_video_path, oss_id)  # 视频发送OSS
                        status = oss_object_key.get("status")
                        if status == 200:
                            # 获取 oss 视频地址
                            oss_object_key = oss_object_key.get("oss_object_key")
                            time.sleep(1)
                            code = PQ.insert_piaoquantv(oss_object_key, new_title, cover, n_id[0])
                            if code:
                                Common.logger("log").info(f"{task_mark}下的视频ID{v_id}发送成功")
                                sqlCollect.insert_task(task_mark, v_id)  # 插入数据库
                                current_time = datetime.now()
                                formatted_time = current_time.strftime("%Y-%m-%d %H:%M:%S")
                                values = [[
                                    name, task_mark, v_id, n_id[0], new_title, str(code), formatted_time
                                ]]
                                Feishu.insert_columns("ILb4sa0LahddRktnRipcu2vQnLb", "a74fc4", "ROWS", 1, 2)
                                time.sleep(0.5)
                                Feishu.update_values("ILb4sa0LahddRktnRipcu2vQnLb", "a74fc4", "A2:Z2", values)
                            if os.path.isfile(new_video_path):
                                os.remove(new_video_path)
                        else:
                            Common.logger("log").info(f"{task_mark}下的视频ID{id} 视频发送OSS失败 ")
                    if old_id != 'None' and old_id != '' and old_id != None:
                        Feishu.bot(mark, '机器自动改造消息通知', f'{task_mark}任务改造完成，请关注', name)
                if video_id != 'None' and video_id != '' and video_id != None:
                    Feishu.bot(mark, '机器自动改造消息通知', f'{task_mark}任务改造完成，请关注', name)
            except Exception as e:
                Common.logger("warning").warning(f"{name}的{task_mark}任务处理失败:{e}\n")
        return mark
















